! ***  Gebietsaufteilung  *****************************************************

function Zellnummer(G,A,i)
      integer::Zellnummer; type(Gebiet)::G; type(Atome)::A; integer::i
  integer::zx,zy
  zx=int((A%a(i)%x(1)-G%x0)/G%d)
  zy=int((A%a(i)%x(2)-G%y0)/G%d)
  if ( (0<=zx) .and. (zx<G%Nx) .and. (0<=zy) .and. (zy<G%Ny) ) then
    Zellnummer=1+zx+zy*G%Nx
  else
    Zellnummer=0
  end if
end function

function Zellen_benachbart(G,i,j)
      logical::Zellen_benachbart; type(Gebiet)::G; integer::i,j
  integer::ix,iy,jx,jy
  ix=mod((i-1),G%Nx); iy=int((i-1)/G%Nx)
  jx=mod((j-1),G%Nx); jy=int((j-1)/G%Nx)
  if ( (i/=0) .and. (j/=0) .and. (abs(ix-jx)<=1) .and. (abs(iy-jy)<=1) ) then
    Zellen_benachbart=.true.
  else
    Zellen_benachbart=.false.
  end if
end function

subroutine Atome_sortieren(G,A)
      type(Gebiet)::G; type(Atome)::A
  integer::i,k,l,z,zn
  type(Atom)::aa 
  ! Anzahl und Startposition fuer jedes Zelle bestimmen
  G%Anzahl(:)=0
  do k=1,A%N
    i=A%a(k)%zelle 
    G%Anzahl(i)=G%Anzahl(i)+1
  end do
  G%Start(0)=1
  do i=1,G%N
    G%Start(i)=G%Start(i-1)+G%Anzahl(i-1)
  end do
  ! Atome einsortieren
  G%Anzahl(:)=0    ! Zahl der richtig einsortierten Atome
  z=0              ! Aktuelle Zelle
  do while (z<G%N)      ! "<", da letzte Zelle automatisch richtig
    ! Solange noch Teilchen in Zelle z fehlen, durch Tauschen welche suchen
    do while ( G%Start(z)+G%Anzahl(z)<G%Start(z+1) )
      k=G%Start(z)+G%Anzahl(z)   ! erstes potentiell falsche Atom in Zelle z
      zn=A%a(k)%zelle            ! Zelle, wo das aktuelle Atom hin muss
      do while (zn/=z)
        ! aktuelles Atom richtig einsortieren und dortiges Atom herholen
        l=G%Start(zn)+G%Anzahl(zn)   ! hier muss das aktuelle Atom hin
        G%Anzahl(zn)=G%Anzahl(zn)+1  ! und hier ist es dann auch richtig
        aa=A%a(l); A%a(l)=A%a(k); A%a(k)=aa  ! Atome k und l tauschen
        zn=A%a(k)%zelle              ! Gebiet des geholten Atoms
      end do
      G%Anzahl(z)=G%Anzahl(z)+1  ! aktuelles Teilchen ist richtig einsortiert
    end do
    z=z+1               ! aktuelle Zelle fertig, also zur naechsten
  enddo
  ! letze Zelle wurde nicht ganz durchlaufen, deshalb noch Anzahl berechnen
  G%Anzahl(G%N)=A%N-G%Start(G%N)+1
end subroutine

subroutine Zellen_initialisieren(G)
      type(Gebiet)::G
  integer::i,j,k
  ! Zelleninitialisieren, Zelle 0 fr verlorene Teilchen
  G%x0=-0.5*NGX
  G%y0=-0.5*NGY
  G%d =R_AB
  G%Nx=int(NGX*RGG/G%d)+1
  G%Ny=int(NGY*RGG/G%d)+1
  G%N=G%Nx*G%Ny           ! Zahl der echten Zellen
  allocate (G%Anzahl(0:G%N))
  allocate (G%Start(0:G%N))
  allocate (G%Nachbar(0:G%N,NACHBARN))
  G%Nachbar(:,:)=-1       ! evtl. nicht vorhandene Nachbarn durch -1 markieren
  do i=0,G%N
    k=0                   ! Zahl der Nachbarzellen von Zelle i
    do j=0,G%N
      if(Zellen_benachbart(G,i,j)) then
        k=k+1
        G%Nachbar(i,k)=j  ! k-ter Nachbar von Zelle i ist j
      end if
    end do
  end do
end subroutine
